#include "Resources.h"

char TFT_DataPort at LATE;
sbit TFT_RST at LATD7_bit;
sbit TFT_BLED at LATD2_bit;
sbit TFT_RS at LATD9_bit;
sbit TFT_CS at LATD10_bit;
sbit TFT_RD at LATD5_bit;
sbit TFT_WR at LATD4_bit;
char TFT_DataPort_Direction at TRISE;
sbit TFT_RST_Direction at TRISD7_bit;
sbit TFT_BLED_Direction at TRISD2_bit;
sbit TFT_RS_Direction at TRISD9_bit;
sbit TFT_CS_Direction at TRISD10_bit;
sbit TFT_RD_Direction at TRISD5_bit;
sbit TFT_WR_Direction at TRISD4_bit;

sbit LEDSYS at LATD14_bit;
sbit LEDSYS_Direction at TRISD14_bit;

unsigned long NVM1,NVM2;
char TXT1[64],TXT2[64];

void DrawFrame(){
  TFT_Fill_Screen(CL_WHITE);
  TFT_Set_Pen(CL_BLACK, 1);
  TFT_Line(20, 220, 300, 220);
  TFT_Line(20,  46, 300,  46);
  TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_RED, FO_HORIZONTAL);
  TFT_Write_Text("FLASH  LIKE  A  EEPROM",50,14);
  TFT_Set_Font(&Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL);
  TFT_Write_Text("EasyPIC Fusion v7", 19, 223);
  TFT_Set_Font(&Verdana12x13_Regular, CL_RED, FO_HORIZONTAL);
  TFT_Write_Text("www.teolab.it", 220, 223);
  TFT_Set_Font(&TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
}

void WriteNvmData() {
 Flash_Erase_Page(0x9D1FFFE0);
 Flash_Write_Word(0x9D1FFFE0,1);
 Flash_Write_Word(0x9D1FFFF0,22);
 Delay_ms(100);
}

void ReadNvmData() {
 NVM1 = *(int*)(0x9D1FFFE0);
 LongWordToStr(NVM1,TXT1);
 TFT_Set_Font(&Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL);
 TFT_Write_Text("DEC1: ",19,50);
 Ltrim(TXT1);
 TFT_Write_Text(TXT1,110,50);
 LongWordToHex(NVM1,TXT1);
 TFT_Write_Text("HEX1: ",19,60);
 TFT_Write_Text(TXT1,110,60);
 
 NVM2 = *(int*)(0x9D1FFFF0);
 LongWordToStr(NVM2,TXT2);
 TFT_Set_Font(&Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL);
 TFT_Write_Text("DEC2: ",19,75);
 Ltrim(TXT2);
 TFT_Write_Text(TXT2,110,75);
 LongWordToHex(NVM2,TXT2);
 TFT_Write_Text("HEX2: ",19,85);
 TFT_Write_Text(TXT2,110,85);
}

void main() {
 ANSELA = 0;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 ANSELE = 0;
 ANSELF = 0;
 ANSELG = 0;
 JTAGEN_bit = 0;
 LEDSYS_Direction = 0;

 TFT_BLED_Direction = 0;
 TFT_Set_Default_Mode();
 TFT_Init_ILI9340_8bit(320,240);
 TFT_BLED = 1;
 DrawFrame();
 
 WriteNvmData();
 ReadNvmData();

 do
 {
  LEDSYS =! LEDSYS;
  Delay_ms(1000);
 }
 while (1);
}